import { ComposableStyles, ViewTemplate } from '@microsoft/fast-element';
import type { AppContext, AppElement, AppMetadata, AppRegistration, AppRoute, AppStore, AppStyle, AppTargetId, AppTokenTypePredicate, HasPredicate, HasTarget } from './types';
/**
 * @param token - A module export token.
 * @public
 */
export declare function isAppMetadata(token: unknown): token is AppMetadata;
/**
 * @param token - A module export token.
 * @public
 */
export declare function isAppRegistration(token: unknown): token is AppRegistration;
/**
 * @param token - A module export token.
 * @public
 */
export declare function isAppRoute(token: unknown): token is AppRoute;
/**
 * @param token - A module export token.
 * @public
 */
export declare function isAppStore(token: unknown): token is AppStore;
/**
 * @param token - A module export token.
 * @public
 */
export declare function isAppElement(token: unknown): token is AppElement;
/**
 * @param token - A module export token / element candidate.
 * @public
 */
export declare function isViewTemplate(token: unknown): token is ViewTemplate;
/**
 * @param token - A module export token.
 * @public
 */
export declare function isAppStyle(token: unknown): token is AppStyle;
/**
 * @param token - A module export token / styles candidate.
 * @public
 */
export declare function isComposableStyles(token: unknown): token is ComposableStyles;
/**
 * @public
 */
export declare const registrationPredicate: <A, P>(asset: A, predicate: P, context: AppContext) => boolean;
/**
 * @public
 */
export declare const targetIdPredicate: (asset: HasTarget, targetId: AppTargetId) => boolean;
/**
 * @public
 */
export declare const assetPredicate: (asset: HasPredicate, context: AppContext) => boolean;
/**
 * @param module - An imported module.
 * @param predicate - Token type predicate.
 * @public
 */
export declare const getQualifiedModuleTokens: <T extends unknown>(module: any, predicate: AppTokenTypePredicate) => T[];
//# sourceMappingURL=utils.d.ts.map