import { getQualifiedModuleTokens } from '../../app/utils';
import { logger } from '../../utils';
/**
 * @param modules - Vite import glob modules.
 * @param predicate - Optional token type predicate.
 * @public
 */
export function importAll(modules, predicate) {
    const imports = Object.keys(modules).reduce((acc, key) => {
        const module = modules[key];
        const tokenArray = getQualifiedModuleTokens(module, predicate);
        return [...acc, ...tokenArray];
    }, []);
    logger.debug('importAll result', imports);
    return imports;
}
