import { getQualifiedModuleTokens } from '../../app/utils';
import { logger } from '../../utils';
/**
 * @param context - Webpack require context.
 * @param predicate - Optional token type predicate.
 * @public
 */
export function importAll(context, predicate) {
    const imports = context.keys().reduce((acc, key) => {
        const module = context(key);
        const tokenArray = getQualifiedModuleTokens(module, predicate);
        return [...acc, ...tokenArray];
    }, []);
    logger.debug('importAll result', imports);
    return imports;
}
