var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
const checkCapabilities = () => {
    if (!('serviceWorker' in navigator)) {
        throw new Error('No Service Worker support!');
    }
    if (!('PushManager' in window)) {
        throw new Error('No Push API support!');
    }
};
const registerServiceWorker = (registrationOptions) => __awaiter(this, void 0, void 0, function* () { return navigator.serviceWorker.register('/sw.js', registrationOptions); });
const requestNotificationPermission = () => __awaiter(this, void 0, void 0, function* () {
    const permission = yield window.Notification.requestPermission();
    if (permission !== 'granted') {
        console.error('Permission not granted for Notification');
    }
});
window.addEventListener('load', () => __awaiter(this, void 0, void 0, function* () {
    checkCapabilities();
    yield requestNotificationPermission();
    yield registerServiceWorker({ scope: '/' });
}));
