## API Report File for "@genesislcap/foundation-shell"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { Behavior } from '@microsoft/fast-element';
import { ComposableStyles } from '@microsoft/fast-element';
import type { DesignSystemModule } from '@genesislcap/foundation-utils';
import type { ElementStyles } from '@microsoft/fast-element';
import { FASTElement } from '@microsoft/fast-element';
import type { FoundationRoute } from '@genesislcap/foundation-ui';
import type { FoundationRouteCollection } from '@genesislcap/foundation-ui';
import type { HasElement } from '@microsoft/fast-router';
import { InterfaceSymbol } from '@microsoft/fast-foundation';
import { RepeatOptions } from '@microsoft/fast-element';
import type { StoreRoot } from '@genesislcap/foundation-store';
import { ViewTemplate } from '@microsoft/fast-element';

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "App" because one of its declarations is marked as @internal
//
// @public
export interface App extends AppAssets, AppRegister, AppValidity {
    readonly config: AppConfig;
    deregisterAssets(): void;
    hasAssets(): boolean;
    registerAssets(assets: Partial<AppAssets>): void;
}

// @internal
export const App: InterfaceSymbol<App>;

// @public
export interface AppAssets {
    readonly elements: AppElement[];
    readonly metadata: AppMetadata[];
    readonly registrations: AppRegistration[];
    readonly routes: AppRoute[];
    readonly stores: AppStore[];
    readonly styles: AppStyle[];
}

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "AppConfig" because one of its declarations is marked as @internal
//
// @public
export interface AppConfig {
    // (undocumented)
    context?: AppContext;
    // (undocumented)
    defaultElementRepeatOptions?: RepeatOptions;
}

// @internal
export const AppConfig: InterfaceSymbol<AppConfig>;

// @public
export type AppContext = {
    env?: string;
    domain?: string;
    user?: {};
    answers?: {};
    featureFlags?: {};
};

// @public
export type AppDependencies = {
    [key: string]: string;
};

// @public
export type AppDependencyPrerequisites = {
    [key: string]: string;
};

// @public (undocumented)
export type AppElement<TSource = any, TParent = any, TTarget = string> = HasTarget<TTarget> & HasPredicate & {
    elements: ViewTemplate<TSource, TParent>;
    placementIndex?: number;
    slotId?: string;
};

// @public
export type AppElementPredicate = (element: AppElement, context?: AppContext) => boolean;

// @public (undocumented)
export type AppMetadata = {
    name: string;
    version: string;
    description?: string;
    dependencies?: AppDependencies;
    prerequisites?: AppDependencyPrerequisites;
};

// @public
export interface AppRegister {
    deregisterElement(element: AppElement): void;
    deregisterRoute(route: AppRoute): void;
    deregisterStore(store: AppStore): void;
    deregisterStyle(style: AppStyle): void;
    registerComponents: RegisterComponents;
    registerElement(element: AppElement): void;
    registerElementsTarget: RegisterElementsTarget;
    registerRoute(route: AppRoute): void;
    registerRouteCollection: RegisterRouteCollection;
    registerStore(store: AppStore): void;
    registerStoreRoot: RegisterStoreRoot;
    registerStyle(style: AppStyle): void;
    registerStylesTarget: RegisterStylesTarget;
}

// @public (undocumented)
export type AppRegistration = (context: AppRegistrationContext) => void;

// @public
export type AppRegistrationContext = {
    designSystem: DesignSystemModule;
};

// @public (undocumented)
export type AppRoute = FoundationRoute & HasElement & HasPredicate;

// @public
export type AppRoutePredicate = (route: AppRoute, context?: AppContext) => boolean;

// @public (undocumented)
export type AppStore<S = any> = HasPredicate & {
    store: S;
};

// @public
export type AppStorePredicate = (store: AppStore, context?: AppContext) => boolean;

// @public (undocumented)
export type AppStyle<T = string> = HasTarget<T> & HasPredicate & {
    styles: ComposableStyles | ComposableStyles[];
};

// @public
export type AppStylePredicate = (style: AppStyle, context?: AppContext) => boolean;

// @public
export type AppTargetId<TTarget = string> = TTarget | TTarget[];

// @public
export type AppTokenTypePredicate = (token: unknown) => boolean;

// @public
export interface AppValidity {
    isValid(context: AppValidityContext): boolean;
}

// @public
export type AppValidityContext = {
    dependencies?: AppDependencies;
    prerequisites?: AppDependencyPrerequisites;
};

// @public
export type AssetPredicate = (context?: AppContext) => boolean;

// @public (undocumented)
export const assetPredicate: (asset: HasPredicate, context: AppContext) => boolean;

// @public
export class DefaultApp implements App {
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "App" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // @internal (undocumented)
    config: AppConfig;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "App" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    deregisterAssets(): void;
    deregisterElement(element: any): void;
    deregisterRoute(route: any): void;
    deregisterStore(store: any): void;
    deregisterStyle(style: any): void;
    elements: AppElement[];
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "App" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    hasAssets(): boolean;
    isValid(context: any): boolean;
    metadata: AppMetadata[];
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "App" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    registerAssets(assets: any): void;
    registerComponents(context: any): void;
    registerElement(element: any): void;
    registerElementsTarget(targetId: any, predicate: any, repeatOptions?: RepeatOptions): ViewTemplate<any, any>;
    registerRoute(route: any): void;
    registerRouteCollection(routeCollection: any, predicate: any): any;
    registerStore(store: any): void;
    registerStoreRoot(storeRoot: any, predicate: any): () => void;
    registerStyle(style: any): void;
    // Warning: (ae-forgotten-export) The symbol "AppStylesTargetBehavior" needs to be exported by the entry point index.docs.d.ts
    registerStylesTarget(targetId: any, predicate: any): AppStylesTargetBehavior;
    registrations: AppRegistration[];
    routes: AppRoute[];
    stores: AppStore[];
    styles: AppStyle[];
}

// @public
export const defaultAppConfig: AppConfig;

// @public (undocumented)
export const DynamicTemplate: ViewTemplate<MainApplication>;

// @public
export function getApp(): App;

// @public (undocumented)
export const getQualifiedModuleTokens: <T extends unknown>(module: any, predicate: AppTokenTypePredicate) => T[];

// @public
export type HasPredicate = {
    predicate?: AssetPredicate;
};

// @public
export type HasTarget<TTarget = string> = {
    targetId: TTarget;
};

// @public
export function importPBCAssets(): Promise<AppAssets>;

// @public (undocumented)
export function isAppElement(token: unknown): token is AppElement;

// @public (undocumented)
export function isAppMetadata(token: unknown): token is AppMetadata;

// @public (undocumented)
export function isAppRegistration(token: unknown): token is AppRegistration;

// @public (undocumented)
export function isAppRoute(token: unknown): token is AppRoute;

// @public (undocumented)
export function isAppStore(token: unknown): token is AppStore;

// @public (undocumented)
export function isAppStyle(token: unknown): token is AppStyle;

// @public (undocumented)
export function isComposableStyles(token: unknown): token is ComposableStyles;

// @public (undocumented)
export function isViewTemplate(token: unknown): token is ViewTemplate;

// @public (undocumented)
export const LoadingTemplate: ViewTemplate<MainApplication>;

// @public (undocumented)
export class MainApplication extends FASTElement {
    // (undocumented)
    connectedCallback(): void;
    // (undocumented)
    ready: boolean;
    // (undocumented)
    selectTemplate(): ViewTemplate<MainApplication, any>;
}

// @public (undocumented)
export const MainTemplate: ViewTemplate<MainApplication>;

// @public
export type RegisterComponents = AppRegistration;

// @public
export type RegisterElementsTarget = <T = string>(targetId: AppTargetId<T>, predicate?: AppElementPredicate, repeatOptions?: RepeatOptions) => ViewTemplate;

// @public
export type RegisterRouteCollection = (routeCollection: FoundationRouteCollection, predicate?: AppRoutePredicate) => (source: unknown) => void;

// @public
export type RegisterStoreRoot = (storeRoot: StoreRoot, predicate?: AppStorePredicate) => (source: unknown) => void;

// @public
export type RegisterStylesTarget = <T = string>(targetId: AppTargetId<T>, predicate?: AppStylePredicate) => Behavior;

// @public (undocumented)
export const registrationPredicate: <A, P>(asset: A, predicate: P, context: AppContext) => boolean;

// @public (undocumented)
export const targetIdPredicate: (asset: HasTarget, targetId: AppTargetId) => boolean;

// (No @packageDocumentation comment for this package)

```
