<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-shell](./foundation-shell.md) &gt; [App](./foundation-shell.app.md)

## App interface

`App` provides APIs to register integration targets for PBCs and other actors to register their assets in bulk via token exports. It also provides specific APIs to add single assets to the application itself, like routes, elements, styles, store fragments etc.

**Signature:**

```typescript
export interface App extends AppAssets, AppRegister, AppValidity 
```
**Extends:** [AppAssets](./foundation-shell.appassets.md)<!-- -->, [AppRegister](./foundation-shell.appregister.md)<!-- -->, [AppValidity](./foundation-shell.appvalidity.md)

## Example 1

App reference via DI.

```ts
import { App } from '@genesislcap/foundation-shell/app';
...
@App private app: App;
```

## Example 2

App reference via getApp util.

```ts
import { getApp } from '@genesislcap/foundation-shell/app';
...
const app = getApp();
```

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [config](./foundation-shell.app.config.md) | <code>readonly</code> | [AppConfig](./foundation-shell.appconfig.md) | High-level app configuration. |

## Methods

|  Method | Description |
|  --- | --- |
|  [deregisterAssets()](./foundation-shell.app.deregisterassets.md) | Deregister assets. |
|  [hasAssets()](./foundation-shell.app.hasassets.md) | Check if the App has registered assets. |
|  [registerAssets(assets)](./foundation-shell.app.registerassets.md) | Register assets from either a globed dynamic import or some predefined AppAssets instance. This is a one time operation. Assets had be subsequently registered and deregistered using their individual APIs. |

