<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-shell](./foundation-shell.md) &gt; [App](./foundation-shell.app.md) &gt; [registerAssets](./foundation-shell.app.registerassets.md)

## App.registerAssets() method

Register assets from either a globed dynamic import or some predefined AppAssets instance. This is a one time operation. Assets had be subsequently registered and deregistered using their individual APIs.

**Signature:**

```typescript
registerAssets(assets: Partial<AppAssets>): void;
```

## Parameters

|  Parameter | Type | Description |
|  --- | --- | --- |
|  assets | Partial&lt;[AppAssets](./foundation-shell.appassets.md)<!-- -->&gt; | [AppAssets](./foundation-shell.appassets.md)<!-- -->. |

**Returns:**

void

## Example 1

Manual `AppAssets` registration.

```ts
app.registerAssets({
  // with or without pbcAssets
  elements: [...],
  metadata: [...],
  registrations: [...],
  routes: [...],
  styles: [...],
  stores: [...],
});
```

## Example 2

PBC `AppAssets` registration.

```ts
import { importPBCAssets } from '@genesislcap/foundation-shell/pbc';
...
const pbcAssets = await importPBCAssets();
...
app.registerAssets(pbcAssets);
```

