<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-shell](./foundation-shell.md) &gt; [AppRegistration](./foundation-shell.appregistration.md)

## AppRegistration type

**Signature:**

```typescript
export type AppRegistration = (context: AppRegistrationContext) => void;
```
**References:** [AppRegistrationContext](./foundation-shell.appregistrationcontext.md)

## Example 1

Simple registration function to include a component and avoid it being tree-shaken out of the build.

```ts
// src/pbc/notify/registrations.ts

export function registerAlerts() {
  FoundationAlerts;
}
```

## Example 2

Combined registration function.

```ts
// src/pbc/notify/registrations.ts

export function register() {
  FoundationAlerts;
  FoundationInbox;
  ...
}
```

## Example 3

Using the host application's registration context to register with the design system and import from it if needed.

```ts
// src/pbc/notify/registrations.ts

export async function registerAlerts(context: AppRegistrationContext) {
  try {
    const { provideDesignSystem, tokenX } = context.designSystem;
    provideDesignSystem().register(foundationAlerts, tokenX);
  } catch (e) {
    console.error('Error registering alerts', e);
  }
}
```
When defining `AppRegistration` functions in a PBC context, consider defining separate register functions if various subcomponents may be conditionally included based on user preferences or runtime predicates.

