<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-shell](./foundation-shell.md) &gt; [AppStore](./foundation-shell.appstore.md)

## AppStore type

**Signature:**

```typescript
export type AppStore<S = any> = HasPredicate & {
    store: S;
};
```
**References:** [HasPredicate](./foundation-shell.haspredicate.md)

## Example 1

AppStore definition example.

```ts
// src/pbc/notify/stores.ts

// Setup the foundation stores your PBC needs to function, then include the following for each:

export function getNotifyStore(): NotifyStore {
  return DI.getOrCreateDOMContainer().get(NotifyStore);
}

// The actual `AppStore` definition
export const notifyAppStore: AppStore<NotifyStore> = {
  store: getNotifyStore(),
};
```

## Example 2

Optional runtime [AssetPredicate](./foundation-shell.assetpredicate.md) function to determine if the asset should be used.

```ts
export const notifyAppStore: AppStore<NotifyStore> = {
  store: getNotifyStore(),
  predicate: (context: AppContext) => true, // < assess the user, permissions, env, domain, etc.
};
```

