<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-shell](./foundation-shell.md) &gt; [AppTargetId](./foundation-shell.apptargetid.md)

## AppTargetId type

A targetId string or an array of targetId strings.

Apps and micro frontends will predefine integration targets that dynamic app assets can target using a `targetId` property. This creates a pull-like effect where the host can live reload itself should any matching asset be lazily added, removed, or customised.

**Signature:**

```typescript
export type AppTargetId<TTarget = string> = TTarget | TTarget[];
```

## Example

Foundation-header example.

```ts
// src/main/targetId.ts

export type NavTargetId = 'nav-start' | 'nav' | 'nav-end';
export type SideNavTargetId = 'side-nav-start' | 'side-nav' | 'side-nav-end';
export type ElementTargetId = HeaderTargetId | NavTargetId | SideNavTargetId;
export type StyleTargetId = 'header';

// src/main/main.template.ts

export const NavTemplate = html<Navigation>`
   ...
   ${app.registerElementsTarget<NavTargetId>('nav-start')}
   ...
`

// src/main/main.styles.ts

export const MainStyles = css`
   ...
`.withBehaviors(getApp().registerStylesTarget<StyleTargetId>('header'));
```

