<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-shell](./foundation-shell.md)

## foundation-shell package

## Classes

|  Class | Description |
|  --- | --- |
|  [DefaultApp](./foundation-shell.defaultapp.md) | Default App implementation. |
|  [MainApplication](./foundation-shell.mainapplication.md) |  |

## Functions

|  Function | Description |
|  --- | --- |
|  [getApp()](./foundation-shell.getapp.md) | Gets App from the DI container. |
|  [importPBCAssets()](./foundation-shell.importpbcassets.md) | <p>A utility for importing PBC assets that have been added to the application's src/pbc directory via genx add.</p><p>The <code>genx</code> builder (webpack or vite) will attempt to dynamically load all PBC assets from the application's <code>src/pbc</code> directory by default. The returned AppAssets can then be applied to the App. Please note that <code>app.registerAssets</code> is a one-time operation, intended for upfront bulk registration. After this point, you must use the single asset APIs of the <code>App</code> for lazy asset registration or deregistration.</p> |
|  [isAppElement(token)](./foundation-shell.isappelement.md) |  |
|  [isAppMetadata(token)](./foundation-shell.isappmetadata.md) |  |
|  [isAppRegistration(token)](./foundation-shell.isappregistration.md) |  |
|  [isAppRoute(token)](./foundation-shell.isapproute.md) |  |
|  [isAppStore(token)](./foundation-shell.isappstore.md) |  |
|  [isAppStyle(token)](./foundation-shell.isappstyle.md) |  |
|  [isComposableStyles(token)](./foundation-shell.iscomposablestyles.md) |  |
|  [isViewTemplate(token)](./foundation-shell.isviewtemplate.md) |  |

## Interfaces

|  Interface | Description |
|  --- | --- |
|  [App](./foundation-shell.app.md) | <code>App</code> provides APIs to register integration targets for PBCs and other actors to register their assets in bulk via token exports. It also provides specific APIs to add single assets to the application itself, like routes, elements, styles, store fragments etc. |
|  [AppAssets](./foundation-shell.appassets.md) | Dynamically registered assets. |
|  [AppConfig](./foundation-shell.appconfig.md) | AppConfig DI interface. |
|  [AppRegister](./foundation-shell.appregister.md) | APIs to register asset targets and assets. These can be lazily registered and deregistered. |
|  [AppValidity](./foundation-shell.appvalidity.md) | APIs to check app validity. |

## Variables

|  Variable | Description |
|  --- | --- |
|  [assetPredicate](./foundation-shell.assetpredicate.md) |  |
|  [defaultAppConfig](./foundation-shell.defaultappconfig.md) | Default AppConfig DI implementation. |
|  [DynamicTemplate](./foundation-shell.dynamictemplate.md) |  |
|  [getQualifiedModuleTokens](./foundation-shell.getqualifiedmoduletokens.md) |  |
|  [LoadingTemplate](./foundation-shell.loadingtemplate.md) |  |
|  [MainTemplate](./foundation-shell.maintemplate.md) |  |
|  [registrationPredicate](./foundation-shell.registrationpredicate.md) |  |
|  [targetIdPredicate](./foundation-shell.targetidpredicate.md) |  |

## Type Aliases

|  Type Alias | Description |
|  --- | --- |
|  [AppContext](./foundation-shell.appcontext.md) | Context passed to predicate functions and other utilities. |
|  [AppDependencies](./foundation-shell.appdependencies.md) | A record of app dependencies. |
|  [AppDependencyPrerequisites](./foundation-shell.appdependencyprerequisites.md) | A record of app dependency prerequisites. |
|  [AppElement](./foundation-shell.appelement.md) |  |
|  [AppElementPredicate](./foundation-shell.appelementpredicate.md) | <p>Determine if [AppElement](./foundation-shell.appelement.md) should be included during runtime integration.</p><p>Provides app, micro frontend, and seed author fine-grained control over what assets they will accept in their target integration points. This is a similar concept to  which may be applied to slotted content. For example the accordion accepts slotted accordionItems only.</p> |
|  [AppMetadata](./foundation-shell.appmetadata.md) |  |
|  [AppRegistration](./foundation-shell.appregistration.md) |  |
|  [AppRegistrationContext](./foundation-shell.appregistrationcontext.md) | Context used during component registration. |
|  [AppRoute](./foundation-shell.approute.md) |  |
|  [AppRoutePredicate](./foundation-shell.approutepredicate.md) | <p>Determine if the [AppRoute](./foundation-shell.approute.md) should be integrated.</p><p>Provides app, micro frontend, and seed author fine-grained control over what assets they will accept in their target integration points.</p> |
|  [AppStore](./foundation-shell.appstore.md) |  |
|  [AppStorePredicate](./foundation-shell.appstorepredicate.md) | <p>Determine if [AppStore](./foundation-shell.appstore.md) should be included during runtime integration.</p><p>Provides app, micro frontend, and seed author fine-grained control over what assets they will accept in their target integration points.</p> |
|  [AppStyle](./foundation-shell.appstyle.md) |  |
|  [AppStylePredicate](./foundation-shell.appstylepredicate.md) | <p>Determine if [AppStyle](./foundation-shell.appstyle.md) should be included during runtime integration.</p><p>Provides app, micro frontend, and seed author fine-grained control over what assets they will accept in their target integration points.</p> |
|  [AppTargetId](./foundation-shell.apptargetid.md) | <p>A targetId string or an array of targetId strings.</p><p>Apps and micro frontends will predefine integration targets that dynamic app assets can target using a <code>targetId</code> property. This creates a pull-like effect where the host can live reload itself should any matching asset be lazily added, removed, or customised.</p> |
|  [AppTokenTypePredicate](./foundation-shell.apptokentypepredicate.md) | Determine if export token should be included in the import all glob. |
|  [AppValidityContext](./foundation-shell.appvaliditycontext.md) | Context used to assess app validity. |
|  [AssetPredicate](./foundation-shell.assetpredicate.md) | Asset runtime predicate function. |
|  [HasPredicate](./foundation-shell.haspredicate.md) | Interface that includes <code>predicate</code> function. |
|  [HasTarget](./foundation-shell.hastarget.md) | Interface that includes <code>targetId</code>. |
|  [RegisterComponents](./foundation-shell.registercomponents.md) | API for Application and Seed authors to register dynamic components. |
|  [RegisterElementsTarget](./foundation-shell.registerelementstarget.md) | API for Application and Seed authors to define dynamic [AppElement](./foundation-shell.appelement.md) integration points. |
|  [RegisterRouteCollection](./foundation-shell.registerroutecollection.md) | API for Application and Seed authors to register the main . |
|  [RegisterStoreRoot](./foundation-shell.registerstoreroot.md) | API for Application and Seed authors to register the . |
|  [RegisterStylesTarget](./foundation-shell.registerstylestarget.md) | API for Application and Seed authors to define dynamic [AppStyle](./foundation-shell.appstyle.md) integration points. |

