<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-shell](./foundation-shell.md) &gt; [RegisterComponents](./foundation-shell.registercomponents.md)

## RegisterComponents type

API for Application and Seed authors to register dynamic components.

**Signature:**

```typescript
export type RegisterComponents = AppRegistration;
```
**References:** [AppRegistration](./foundation-shell.appregistration.md)

## Example

Register components.

```ts
export async function registerComponents() {
  const designSystem = await designSystemImport();
  const { provideDesignSystem, baseComponents } = designSystem;
  ...
  // Register any pbc components with the design system
  getApp().registerComponents({
    designSystem,
  });
  ...
  provideDesignSystem().register(...);
}
```
PBCs or other application assets may need to register components with the design system of the application, or simply to ensure they are referenced, so they can be used in template literals without the risk of them being tree-shaken out by the application's build process.

