<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-shell](./foundation-shell.md) &gt; [RegisterElementsTarget](./foundation-shell.registerelementstarget.md)

## RegisterElementsTarget type

API for Application and Seed authors to define dynamic [AppElement](./foundation-shell.appelement.md) integration points.

**Signature:**

```typescript
export type RegisterElementsTarget = <T = string>(targetId: AppTargetId<T>, predicate?: AppElementPredicate, repeatOptions?: RepeatOptions) => ViewTemplate;
```
**References:** [AppTargetId](./foundation-shell.apptargetid.md)<!-- -->, [AppElementPredicate](./foundation-shell.appelementpredicate.md)

## Example 1

Register elements targets within a  template literal. An array can be used to integrate assets targeting N number of targets to the one integration location, ie. `['layout', 'layout-end']`<!-- -->.

```ts
html`
 ${app.registerElementsTarget('layout-start')}
 ...
 ${app.registerElementsTarget(['layout', 'layout-end'])}
`
```

## Example 2

Providing a predicate function to filter what elements you will allow.

```ts
html`
 ${app.registerElementsTarget('admin-tools', (element: AppElement, context: AppContext) => {
   return context.user.isAdmin();
 })}
`
```

