// eslint-disable-next-line @typescript-eslint/no-magic-numbers
const iconSizes = [96, 128, 192, 256, 384, 512];
const maximumFileSizeToCache = 5242880;

export default {
  app: {
    rootElement: 'foundation-shell',
  },
  pwa: {
    publicPath: '/',
    name: 'Progressive App Shell',
    short_name: 'PAS',
    description: 'The foundation-shell',
    background_color: '#ffffff',
    crossorigin: 'use-credentials',
    icons: [
      {
        src: './public/assets/icon.svg',
        sizes: iconSizes,
      },
    ],
  },
  serviceWorker: {
    registration: 'serviceWorker/registration.ts',
    worker: 'serviceWorker/serviceWorker.ts',
    assetName: 'sw.js',
    exclude: [/\.map$/, /\.htaccess$/, /LICENSE\.txt/, /swRegistration\.js$/, /sw\.js$/],
    maximumFileSizeToCache,
  },
};
